// INpMac.h : INpMac.DLL main header
//

#pragma once


#ifdef INPMAC_EXPORTS
#ifndef _WIN64
#define INPMAC_API __declspec(dllexport)
#else
#define INPMAC_API
#endif
#else
#define INPMAC_API __declspec(dllimport)
#endif



#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/******************************/
/* API FUNCTIONS              */
/******************************/
//------------------------------------------------------
// M Area Access
//------------------------------------------------------
// get area size
int INPMAC_API __stdcall INpMac_Get_Marea_Size( void );
// get area data
int INPMAC_API __stdcall INpMac_Get_Marea( int Offset, BYTE *lpData, int Buff_Size );
// set area data
int INPMAC_API __stdcall INpMac_Set_Marea( int Offset, BYTE *lpData, int Buff_Size );


//------------------------------------------------------
// [MemDrv] Q Area Access
//------------------------------------------------------
// get area size
int INPMAC_API __stdcall INpMac_Get_Qarea_Size( int GroupNo );
// get area data
int INPMAC_API __stdcall INpMac_Get_Qarea( int GroupNo, int Offset, BYTE *lpData, int Buff_Size );


//------------------------------------------------------
// [MemDrv] I Area Access
//------------------------------------------------------
// get area size
int INPMAC_API __stdcall INpMac_Get_Iarea_Size( int GroupNo );
// set area data
int INPMAC_API __stdcall INpMac_Set_Iarea(int GroupNo, int Offset, BYTE *lpData, int Buff_Size );
// get area data
int INPMAC_API __stdcall INpMac_Get_Iarea( int GroupNo, int Offset, BYTE *lpData, int Buff_Size );

#ifdef __cplusplus
}
#endif /* __cplusplus */


/******************************/
/* ERROR CODES                */
/******************************/
#define	E_INPMAC_SYSTEM_DOWN		0x80000000
#define	E_INPMAC_GROUP_NO_UNKNOWN	0x80000001
#define	E_INPMAC_INVALID_OFFSET		0x80000002
#define	E_INPMAC_MEM_ALIGMENT		0x80000003
#define	E_INPMAC_INVALID_PARAM		0x80000004
#define	E_INPMAC_NOT_EXECUTION		0x80000005

