#pragma once

#ifdef INPMACWIN_EXPORTS
#ifndef _WIN64
#define INPMACWIN_API __declspec(dllexport)
#else
#define INPMACWIN_API
#endif
#else
#define INPMACWIN_API __declspec(dllimport)
#endif


#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/******************************/
/* API FUNCTIONS              */
/******************************/	
	//--------------------------------------------------
	// sharedmemory acccess
	//--------------------------------------------------
	int INPMACWIN_API __stdcall INpMacWin_CreateMemory( HANDLE *phMap, LPCTSTR pName, int Mem_Size );

	int INPMACWIN_API __stdcall INpMacWin_DeleteMemory( HANDLE hMap );

	int INPMACWIN_API __stdcall INpMacWin_ReadMemory( HANDLE hMap, int Offset ,BYTE *lpData ,int Buff_Size );

	int INPMACWIN_API __stdcall INpMacWin_WriteMemory( HANDLE hMap, int Offset ,BYTE *lpData ,int Buff_Size );

	int	INPMACWIN_API __stdcall INpMacWin_MapMemory( HANDLE	hMap, LPVOID *lpMem );

	int	INPMACWIN_API __stdcall INpMacWin_UnMapMemory( LPVOID pMem );

	int	INPMACWIN_API __stdcall INpMacWin_GetSize( LPVOID pMem );

	//--------------------------------------------------
	// sharedmemory acccess (size-unlimited ver.)
	//--------------------------------------------------
	int INPMACWIN_API __stdcall INpMacWin_CreateMemoryEx( HANDLE *phMem, LPCTSTR pName, DWORD dwMaxSize );								
	
	int INPMACWIN_API __stdcall INpMacWin_DeleteMemoryEx( HANDLE hMem );																		
	
	int INPMACWIN_API __stdcall INpMacWin_ReadMemoryEx( HANDLE hMem, DWORD dwOffset, void *lpData, DWORD dwMaxSize, DWORD *pdwReadSize );	
	
	int INPMACWIN_API __stdcall INpMacWin_WriteMemoryEx( HANDLE hMem, DWORD dwOffset, void *lpData, DWORD dwMaxSize, DWORD *pdwWriteSize );
	
	int	INPMACWIN_API __stdcall INpMacWin_MapMemoryEx( HANDLE	hMem, DWORD dwOffset, LPVOID *lpMap, DWORD dwMaxSize );
	
	int	INPMACWIN_API __stdcall INpMacWin_UnMapMemoryEx( LPVOID pMap );

	int INPMACWIN_API __stdcall INpMacWin_GetSizeEx( LPVOID pMap, DWORD *pdwMemSize );


#ifdef __cplusplus
}
#endif /* __cplusplus */


/******************************/
/* ERROR CODES                */
/******************************/
#define S_INPMACWIN_ALREADY_EXISTS		0x000000B7

#define	E_INPMACWIN_FAILED_CREATE		0x80010000
#define	E_INPMACWIN_FAILED_DELETE		0x80010001
#define	E_INPMACWIN_INVALID_OFFSET		0x80010002
#define	E_INPMACWIN_FAILED_ACCESS		0x80010003
#define	E_INPMACWIN_INVALID_PARAM		0x80010004
#define	E_INPMACWIN_NOT_ENOUGH_MEMORY	0x80010005