/*****************************************************************************
*
* FILE NAME:    RtProcess.c
*
* DESCRIPTION:	CvOW[
*
\*****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <rt.h>


#include "RtProcess.h"

// O[oϐ
	RTHANDLE hRootProcess;
	DWORD    dwKtickInUsecs;
// W[\
struct				_INIT {
	enum States			{	BEFORE_INIT,
							INIT_BUSY,
							INIT_DONE,
							CLEANUP_BUSY 
	}					state;
	RTHANDLE			hMain;
	BOOL				bCataloged;
	// Lp̐錾

	PVOID				pMAC_MEM1;
	RTHANDLE			hMAC_MEM1;

	PVOID				pMAC_MEM2;
	RTHANDLE			hMAC_MEM2;

}				strInit;

static void			Cleanup(void);

/*****************************************************************************
*
* FUNCTION:     main
*
* DESCRIPTION:
*  ̓CvOW[ł
*  LAׂẴXbhAׂẴIuWFNg𐶐܂
*  main֐I܂ł̊ԃvZXƂđ݂AIɂ
*  ׂĂ͍폜܂
*
\*****************************************************************************/

void        main(void)
{
	SYSINFO   sysinfo;
	EVENTINFO eiEventInfo;


	printf("INpMacAP started\n");

	// [gvZX擾is܂j
	hRootProcess = GetRtThreadHandles(ROOT_PROCESS);

	// W[\̂NA܂
	memset(&strInit, 0, sizeof(strInit));
	strInit.state = BEFORE_INIT;
	
	// ჌xeBbNli}CNbj擾܂
	if (!CopyRtSystemInfo(&sysinfo))
		Fail("Cannot copy system info");
	dwKtickInUsecs = 10000 / sysinfo.KernelTickRatio;
	if (dwKtickInUsecs == 0)
		Fail("Invalid low level tick length");

	// vZX̍ővCIeB𒲐܂is͖܂j
	SetRtProcessMaxPriority(NULL_RTHANDLE, 150);

	// CXbhi̊֐j̃nh擾܂
	strInit.hMain = GetRtThreadHandles(THIS_THREAD);
	strInit.state = INIT_BUSY;

	// ̃vZX̃nh[gvZXɃJ^O܂
	if (!Catalog(hRootProcess,
			GetRtThreadHandles(THIS_PROCESS),
			"INpMacAP"))
		Fail("Cannot catalog process name");
	strInit.bCataloged = TRUE;

	// *****************************************
	//  L[MAC_MEM1]̊m
	// *****************************************
	strInit.pMAC_MEM1 = AllocateRtMemory(4096);
	if (strInit.pMAC_MEM1 == NULL)
		Fail("Cannot allocate shared memory MAC_MEM1");
	strInit.hMAC_MEM1 = CreateRtMemoryHandle(
						strInit.pMAC_MEM1, 4096);
	if (strInit.hMAC_MEM1 == BAD_RTHANDLE)
	{
		strInit.hMAC_MEM1 = NULL_RTHANDLE;
		Fail("Cannot create a handle for shared memory MAC_MEM1");
	}
	// ROOTփJ^O
	if (!Catalog(hRootProcess, strInit.hMAC_MEM1, "MAC_MEM1"))
		Fail("Cannot catalog shared memory MAC_MEM1");
	
	
	printf("\n---------------------------------------\n"
			"[MEMORY_1]\n"
			"NAME: MAC_MEM1    PROCESS: (ROOT)\n"
			"SIZE: 4096 byte\n"
			"---------------------------------------\n"
			);

	// *****************************************
	//  L[MAC_MEM2]̊m
	// *****************************************
	strInit.pMAC_MEM2 = AllocateRtMemory(4096);
	if (strInit.pMAC_MEM2 == NULL)
		Fail("Cannot allocate shared memory MAC_MEM2");
	strInit.hMAC_MEM2 = CreateRtMemoryHandle(
						strInit.pMAC_MEM2, 4096);
	if (strInit.hMAC_MEM2 == BAD_RTHANDLE)
	{
		strInit.hMAC_MEM2 = NULL_RTHANDLE;
		Fail("Cannot create a handle for shared memory MAC_MEM2");
	}
	// ̃vZXփJ^O
	if (!Catalog(NULL_RTHANDLE, strInit.hMAC_MEM2, "MAC_MEM2"))
		Fail("Cannot catalog shared memory MAC_MEM2");

	printf("\n---------------------------------------\n"
			"[MEMORY_2]\n"
			"NAME: MAC_MEM2    PROCESS: INpMacAP\n"
			"SIZE: 4096 byte\n"
			"---------------------------------------\n"
			);



	// Ƃ܂
	strInit.state = INIT_DONE;
	printf("RtProcess finished initialization\n");

	// Cxg҂܂
	while (RtNotifyEvent(RT_SYSTEM_NOTIFICATIONS | RT_EXIT_NOTIFICATIONS,
						WAIT_FOREVER,
						&eiEventInfo))
	{
		switch(eiEventInfo.dwNotifyType)
		{
		case TERMINATE:
			// TODO: ̃vZXIƂ̏
			// N[Abv܂
			Cleanup();  // ߂邱Ƃ͂܂
	
		case RT_CLIENT_DOWN:
			// TODO: NTzXgɂRTNCAg̃_EɔƂ̏
			break;

		case RT_CLIENT_UP:
			// TODO: NTzXgɂRTNCAg̕AɔƂ̏
			break;

		case NT_HOST_DOWN:
			// TODO: RTNCAgɂNTzXg̃_EɔƂ̏
			break;

		case NT_HOST_UP:
			// TODO: RTNCAgɂNTzXg̕AɔƂ̏
			break;

		case NT_BLUESCREEN:
			// TODO: NT̃u[XN[oƂ̏
			break;
		}
	}
	Fail("Notify failed");
}


/*****************************************************************************
*
* FUNCTION:			Fail
*
* PARAMETERS:		printfl̃p[^҂܂
*
* RETURNS:			̊֐珈߂邱Ƃ͂܂
*
* DESCRIPTION:
*  fobO[hɂăbZ[W\܂
*  ̂Ƃ݂̃vZX͖ɍ폜܂
\*****************************************************************************/

void        Fail(
					LPSTR       lpszMessage, ...)
{
	EXCEPTION   eh;
	RTHANDLE    hDelMbx;
	DWORD     dwTerminate;

#ifdef _DEBUG
	va_list     ap;

	va_start(ap, lpszMessage);
	vprintf(lpszMessage, ap);
	va_end(ap);
	printf("\nError nr=%x\n", GetLastRtError());
#endif

	// O𒲍܂
	GetRtExceptionHandlerInfo(THREAD_HANDLER, &eh);
	eh.ExceptionMode = 0;
	SetRtExceptionHandler(&eh);

	// ܂JnĂȂԂł͒ɏI܂
	if (strInit.state == BEFORE_INIT)
		exit(0);

	if (strInit.hMain == GetRtThreadHandles(THIS_THREAD))
	{
		// CXbh̏ꍇF
		// ƒȂ΃N[Abv܂
		if (strInit.state == INIT_BUSY)
			Cleanup();  // ߂邱Ƃ͂܂

		// CXbh̏ꍇF
		// ݏƂsĂȂƂreturnɂI܂
		return;
	}

	// CXbhȊOF
	// CXbhɃN[Abv̎sv܂
	// i폜v[𑗂jG[͖܂
	hDelMbx = LookupRtHandle(NULL_RTHANDLE, "R?EXIT_MBOX", 5000);
	dwTerminate = TERMINATE;
	SendRtData(hDelMbx, &dwTerminate, 4);
	SuspendRtThread(NULL_RTHANDLE);

	// ̓TXyhsӖ܂
	while (1)
		RtSleep(655349);	// ő܂ŃX[v܂
}


/*****************************************************************************
*
* FUNCTION:   Cleanup (local function)
*
* DESCRIPTION:
*  SẴIuWFNg폜܂
*
*
\*****************************************************************************/

void      Cleanup(void)
{
	// N[Abvƒ܂
	strInit.state = CLEANUP_BUSY;

	// L܂

	if (strInit.hMAC_MEM1 != NULL_RTHANDLE)
	{
		if (!UncatalogRtHandle(hRootProcess, "INpMacAP"))
			Fail("Cannot remove my own name");
		if (!DeleteRtMemoryHandle(strInit.hMAC_MEM1))
			Fail("Cannot free shared memory handle MAC_MEM1");
	}
	if (strInit.pMAC_MEM1 != NULL)
		if (!FreeRtMemory(strInit.pMAC_MEM1))
			Fail("Cannot free shared memory MAC_MEM1");

	if (strInit.hMAC_MEM2 != NULL_RTHANDLE)
		if (!DeleteRtMemoryHandle(strInit.hMAC_MEM2))
			Fail("Cannot free shared memory handle MAC_MEM2");
	
	if (strInit.pMAC_MEM2 != NULL)
		if (!FreeRtMemory(strInit.pMAC_MEM2))
			Fail("Cannot free shared memory MAC_MEM2");

	// [gvZX̃J^O炱̃vZX̃J^O폜܂
	if (strInit.bCataloged)
		if (!UncatalogRtHandle(hRootProcess, "INpMacAP"))
			Fail("Cannot remove my own name");

#ifdef _DEBUG
	printf("RtProcess finished cleaning up\n");
#endif

	// vZXI
	exit(0);
}
