﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Sample
{
    public partial class Form1 : Form
    {
        //------------------------------------------
        // MODE
        public const byte MAC_MD_UNUSED = 0;
        public const byte MAC_MD_GET_QAREA_SIZE = 1;
        public const byte MAC_MD_GET_IAREA_SIZE = 2;
        public const byte MAC_MD_GET_QAREA = 3;
        public const byte MAC_MD_SET_IAREA = 4;
        public const byte MAC_MD_RW_RT_DATA = 5;
        public const byte MAC_MD_GET_RT_SIZE = 6;
        public const byte MAC_MD_GET_MAREA_SIZE = 7;
        public const byte MAC_MD_GET_MAREA = 8;
        public const byte MAC_MD_SET_MAREA = 9;

        //------------------------------------------
        // DATA TYPE
        public const byte MAC_DT_BYTE = 0;
        public const byte MAC_DT_WORD = 1;
        public const byte MAC_DT_DWORD = 2;
        public const byte MAC_DT_CHAR = 3;
        public const byte MAC_DT_SHORT = 4;
        public const byte MAC_DT_LONG = 5;
        public const byte MAC_DT_FLOAT = 6;
        public const byte MAC_DT_DOUBLE = 7;
        public const byte MAC_DT_STR_W = 8;
        public const byte MAC_DT_STR_M = 9;
        public const byte MAC_DT_BIT = 10;


        public Form1()
        {
            InitializeComponent();

            Load_Prop();    // プロパティをロード
            Disp_Prop();    // 結果表示
        }



        private void button1_Click(object sender, EventArgs e)
        {
            Save_Prop();    // プロパティを設定
            Disp_Prop();    // 結果表示
        }



        ///////////////////////////////////////////
        // Get Property
        private void Load_Prop()
        {
            // Property Load
            txtProcName.Text = axINpMac1.ProcessName;
            txtMemName.Text = axINpMac1.MemoryName;
            cmbMode.SelectedIndex = axINpMac1.Mode;
            txtOffset.Text = axINpMac1.Offset.ToString();
            cmbBitOffset.SelectedIndex = axINpMac1.BitOffset;
            cmbType.SelectedIndex = axINpMac1.Type;
            txtValue.Text = "";
            txtStatus.Text = axINpMac1.Status.ToString();
        }

        ///////////////////////////////////////////
        // Set Property
        private void Save_Prop()
        {
            // Property Set
            axINpMac1.ProcessName = txtProcName.Text;
            axINpMac1.MemoryName = txtMemName.Text;
            axINpMac1.Mode = (byte)cmbMode.SelectedIndex;
            axINpMac1.Offset = Convert.ToInt32(txtOffset.Text);
            axINpMac1.BitOffset = (byte)cmbBitOffset.SelectedIndex;
            axINpMac1.Type = (byte)cmbType.SelectedIndex;
          
            // ! Value = "" then Read Only.
            if (txtValue.Text.Length > 0)
            {
                axINpMac1.Value = (object)txtValue.Text;
            }
            else
            {
                switch (axINpMac1.Mode)
                {
                 case MAC_MD_SET_IAREA:
                 case MAC_MD_SET_MAREA:
                     MessageBox.Show("This mode is write-only.", "WARNING!!!", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                     break;
                }
            
            }

        }

        ///////////////////////////////////////////
        // Now Property
        private void Disp_Prop()
        {
            object vValue;

            txtMemName2.Text = axINpMac1.MemoryName;
            txtMode2.Text = cmbMode.Items[axINpMac1.Mode].ToString();
            txtOffset2.Text = axINpMac1.Offset.ToString();
            txtBitOffset2.Text = cmbBitOffset.Items[axINpMac1.BitOffset].ToString();
            txtType2.Text = cmbType.Items[axINpMac1.Type].ToString();
            
            // Value Set
            vValue = axINpMac1.Value;
            switch (axINpMac1.Mode)
            {
            case MAC_MD_UNUSED:         // MODE: Unused
                txtValue2.Text = vValue.ToString();
                break;

            case MAC_MD_GET_QAREA:    // MODE: Memory R/W
            case MAC_MD_SET_IAREA:
            case MAC_MD_RW_RT_DATA:
            case MAC_MD_GET_MAREA:
            case MAC_MD_SET_MAREA:
                switch (axINpMac1.Type)
                {
                case MAC_DT_FLOAT:              // Single Type
                    txtValue2.Text = string.Format("{0}",vValue);
                    break;
                case MAC_DT_DOUBLE:             // Double Type
                    txtValue2.Text = string.Format("{0}",vValue);
                    break;
                case MAC_DT_STR_W:
                case MAC_DT_STR_M:              // String Type  
                    txtValue2.Text = string.Format("\"{0}\"",vValue);
                    break;
                default:                        // Other Type
                    txtValue2.Text = string.Format("{0}({0:X8}h)", vValue);
                    break;
                }
                break;

            case MAC_MD_GET_QAREA_SIZE:       // MODE: Get Size
            case MAC_MD_GET_IAREA_SIZE:
            case MAC_MD_GET_RT_SIZE:
            case MAC_MD_GET_MAREA_SIZE:
                txtValue2.Text = string.Format("{0}({0:X8}h)", vValue);
                break;                
            }
            
            // Status Set
            txtStatus2.Text = string.Format("{0}({0:X8}h)", axINpMac1.Status);
        }

        private void axINpMac1_OnError(object sender, AxINpMacLib._DINpMacEvents_OnErrorEvent e)
        {
            MessageBox.Show(string.Format("Error: 0x{0:X8} ({0})", e.errCode), "Error!!!", MessageBoxButtons.OK, MessageBoxIcon.Error);
        }
        

    }


}
